#include "matrix.h"
#include <cassert>

void Matrix::create(int m1,int n1) {
    // Note the parameters are not called m and n
    // to avoid confusion with fields!
    m=m1;
    n=n1;
    t=new double[m*n];
}

void Matrix::destroy() {
    delete[] t;
}

double Matrix::get(int i,int j) {
	return t[i+m*j];
}

void Matrix::set(int i,int j,double x) {
	t[i+m*j]=x;
}

void Matrix::display(string s) {
    cout << s << " =" << endl;
    for(int i=0; i<m; i++) {
        for(int j=0; j<n; j++)
            cout << get(i,j) << " ";
        cout << endl;
    }
}

// A*B is A.operator*(B), hence
// all fields and functions used directly
// address what was prefixed by A before.
Matrix Matrix::operator*(Matrix B) {
    if(n!=B.m) {
        cout << "Error!" << endl;
        exit(1);
    }
    Matrix C;
    C.create(m,B.n);
    for(int i=0; i<m; i++)
        for(int j=0; j<B.n; j++) {
            // Cij=Ai0*B0j+Ai1*B1j+...
            C.set(i,j,0);
            for(int k=0; k<n; k++)
                C.set(i,j,
                      C.get(i,j)+get(i,k)*B.get(k,j));
        }
    return C;
}

int Matrix::nbRow() {
	return m; 
}

int Matrix::nbCol() {
	return n;
}
